Index: /LMDZ5/branches/testing/libf/phylmd/yamada4.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/yamada4.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/yamada4.F90	(revision 2594)
@@ -621,2 +685,273 @@
   RETURN
 END SUBROUTINE vdif_q2e
+
+!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+
+!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+SUBROUTINE mixinglength(ni, nsrf, ngrid,iflag_pbl,pbl_lmixmin_alpha,lmixmin,zlay,zlev,u,v,q2,n2, lmix)
+
+
+
+  USE dimphy
+  USE phys_state_var_mod, only: zstd, zsig, zmea
+  USE phys_local_var_mod, only: l_mixmin, l_mix
+
+ ! zstd: ecart type de la'altitud e sous-maille
+ ! zmea: altitude moyenne sous maille
+ ! zsig: pente moyenne de le maille
+
+  USE geometry_mod, only: cell_area
+  ! aire_cell: aire de la maille
+
+  IMPLICIT NONE
+!*************************************************************************
+! Subrourine qui calcule la longueur de m??lange dans le sch??ma de turbulence
+! avec la formule de Blackadar 
+! Calcul d'un  minimum en fonction de l'orographie sous-maille:
+! L'id??e est la suivante: plus il y a de relief, plus il y a du m??lange
+! induit par les circulations meso et submeso ??chelles.
+!
+! References: * The vertical distribution of wind and turbulent exchange in a neutral atmosphere
+!               Blackadar A.K.
+!               J. Geophys. Res., 64, No 8, 1962
+!
+!             * An evaluation of neutral and convective planetary boundary-layer parametrisations relative 
+!               to large eddy simulations
+!               Ayotte K et al 
+!               Boundary Layer Meteorology, 79, 131-175, 1996
+!
+!
+!             * Local Similarity in the Stable Boundary Layer and Mixing length Approaches: consistency of concepts
+!               Van de Wiel B.J.H et al
+!               Boundary-Lay Meteorol, 128, 103-166, 2008
+!
+!
+! Histoire:
+!----------
+! * premi??re r??daction, Etienne et Frederic, 09/06/2016
+!
+! ***********************************************************************
+
+!==================================================================
+! Declarations
+!==================================================================
+
+! Inputs
+!-------
+ INTEGER            ni(klon)           ! indice sur la grille original (non restreinte)
+ INTEGER            nsrf               ! Type de surface
+ INTEGER            ngrid              ! Nombre de points concern??s sur l'horizontal
+ INTEGER            iflag_pbl          ! Choix du sch??ma de turbulence
+ REAL            pbl_lmixmin_alpha  ! on active ou non le calcul de la longueur de melange minimum
+ REAL               lmixmin            ! Minimum absolu de la longueur de m??lange
+ REAL               zlay(klon, klev)   ! altitude du centre de la couche
+ REAL               zlev(klon, klev+1) ! atitude de l'interface inf??rieure de la couche
+ REAL               u(klon, klev)      ! vitesse du vent zonal
+ REAL               v(klon, klev)      ! vitesse du vent meridional
+ REAL               q2(klon, klev+1)   ! energie cin??tique turbulente 
+ REAL               n2(klon, klev+1)   ! frequence de Brunt-Vaisala
+
+!In/out
+!-------
+
+  LOGICAL, SAVE :: firstcall = .TRUE.
+  !$OMP THREADPRIVATE(firstcall)
+
+! Outputs
+!---------
+
+ REAL               lmix(klon, klev+1)    ! Longueur de melange  
+
+
+! Local
+!-------
+  
+ INTEGER  ig,jg, k
+ REAL     h_oro(klon)
+ REAL     hlim(klon)
+ REAL, SAVE :: kap=0.4,kapb=0.4
+ REAL zq
+ REAL sq(klon), sqz(klon)
+ REAL, ALLOCATABLE, SAVE :: l0(:)
+  !$OMP THREADPRIVATE(l0)
+ REAL fl, zzz, zl0, zq2, zn2
+ REAL famorti, zzzz, zh_oro, zhlim
+ REAL l1(klon, klev+1), l2(klon,klev+1)
+ REAL winds(klon, klev)
+ REAL xcell
+ REAL zstdslope(klon)  
+ REAL lmax
+ REAL l2strat, l2neutre, extent  
+ REAL l2limit(klon)
+!===============================================================
+! Fonctions utiles
+!===============================================================
+
+! Calcul de l suivant la formule de Blackadar 1962 adapt??e par Ayotte 1996
+!..........................................................................
+
+ fl(zzz, zl0, zq2, zn2) = max(min(l0(ig)*kap*zlev(ig, &
+    k)/(kap*zlev(ig,k)+l0(ig)),0.5*sqrt(q2(ig,k))/sqrt( &
+    max(n2(ig,k),1.E-10))), 1.E-5)
+ 
+! Fonction d'amortissement de la turbulence au dessus de la montagne
+! On augmente l'amortissement en diminuant la valeur de hlim (extent) dans le code
+!.....................................................................
+
+ famorti(zzzz, zh_oro, zhlim)=(-1.)*ATAN((zzzz-zh_oro)/(zhlim-zh_oro))*2./3.1416+1.    
+
+  IF (ngrid==0) RETURN
+
+  IF (firstcall) THEN
+    ALLOCATE (l0(klon))
+    firstcall = .FALSE.
+  END IF
+
+
+!=====================================================================
+!         CALCUL de la LONGUEUR de m??lange suivant BLACKADAR: l1
+!=====================================================================
+
+
+  IF (iflag_pbl==8 .OR. iflag_pbl==10) THEN
+
+    
+    ! Iterative computation of l0
+    ! This version is kept for iflag_pbl only for convergence
+    ! with NPv3.1 Cmip5 simulations
+    !...................................................................
+
+    DO ig = 1, ngrid
+      sq(ig) = 1.E-10
+      sqz(ig) = 1.E-10
+    END DO
+    DO k = 2, klev - 1
+      DO ig = 1, ngrid
+        zq = sqrt(q2(ig,k))
+        sqz(ig) = sqz(ig) + zq*zlev(ig, k)*(zlay(ig,k)-zlay(ig,k-1))
+        sq(ig) = sq(ig) + zq*(zlay(ig,k)-zlay(ig,k-1))
+      END DO
+    END DO
+    DO ig = 1, ngrid
+      l0(ig) = 0.2*sqz(ig)/sq(ig)
+    END DO
+    DO k = 2, klev
+      DO ig = 1, ngrid
+        l1(ig, k) = fl(zlev(ig,k), l0(ig), q2(ig,k), n2(ig,k))
+      END DO
+    END DO
+
+  ELSE
+
+    
+    ! In all other case, the assymptotic mixing length l0 is imposed (150m)
+    !......................................................................
+
+    l0(1:ngrid) = 150.
+    DO k = 2, klev
+      DO ig = 1, ngrid
+        l1(ig, k) = fl(zlev(ig,k), l0(ig), q2(ig,k), n2(ig,k))
+      END DO
+    END DO
+
+  END IF
+
+!=================================================================================
+!  CALCUL d'une longueur de melange en fonctions de la topographie sous maille: l2
+! si plb_lmixmin_alpha=TRUE et si on se trouve sur de la terre ( pas actif sur les 
+! glacier, la glace de mer et les oc??ans)
+!=================================================================================
+
+   l2(1:ngrid,:)=0.0
+   l_mixmin(1:ngrid,:,nsrf)=0.
+   l_mix(1:ngrid,:,nsrf)=0.
+
+   IF (nsrf .EQ. 1) THEN
+
+! coefficients 
+!--------------
+
+     extent=2.                                                         ! On ??tend l'impact du relief jusqu'?? extent*h, extent >1.  
+     lmax=150.                                                         ! Longueur de m??lange max dans l'absolu
+
+! calculs
+!---------
+
+     DO ig=1,ngrid
+
+      ! On calcule la hauteur du relief
+      !.................................
+      ! On ne peut pas prendre zstd seulement pour caracteriser le relief sous maille
+      ! car sur un terrain pentu mais sans relief, zstd est non nul (comme en Antarctique, C. Genthon)
+      ! On corrige donc zstd avec l'ecart type de l'altitude dans la maille sans relief 
+      ! (en gros, une maille de taille xcell avec une pente constante zstdslope)
+      jg=ni(ig) 
+!     IF (zsig(jg) .EQ. 0.) THEN
+!          zstdslope(ig)=0.         
+!     ELSE
+!     xcell=sqrt(cell_area(jg))
+!     zstdslope(ig)=max((xcell*zsig(jg)-zmea(jg))**3 /(3.*zsig(jg)),0.)
+!     zstdslope(ig)=sqrt(zstdslope(ig))
+!     END IF
+      
+!     h_oro(ig)=max(zstd(jg)-zstdslope(ig),0.)   ! Hauteur du relief
+      h_oro(ig)=zstd(jg)
+      hlim(ig)=extent*h_oro(ig)     
+     ENDDO
+
+     l2limit(1:ngrid)=0.
+
+     DO k=2,klev
+        DO ig=1,ngrid
+           winds(ig,k)=sqrt(u(ig,k)**2+v(ig,k)**2)
+           IF (zlev(ig,k) .LE. h_oro(ig)) THEN  ! sous l'orographie
+              l2strat= kapb*pbl_lmixmin_alpha*winds(ig,k)/sqrt(max(n2(ig,k),1.E-10))  ! si stratifi??, amplitude d'oscillation * kappab (voir Van de Wiel et al 2008)
+              l2neutre=kap*zlev(ig,k)*h_oro(ig)/(kap*zlev(ig,k)+h_oro(ig))            ! Dans le cas neutre, formule de blackadar. tend asymptotiquement vers h
+              l2neutre=MIN(l2neutre,lmax)                                             ! On majore par lmax 
+              l2limit(ig)=MIN(l2neutre,l2strat)                                       ! Calcule de l2 (minimum de la longueur en cas neutre et celle en situation stratifi??e)
+              l2(ig,k)=l2limit(ig)
+                                      
+           ELSE IF (zlev(ig,k) .LE. hlim(ig)) THEN ! Si on est au dessus des montagnes, mais affect?? encore par elles
+
+      ! Au dessus des montagnes, on prend la l2limit au sommet des montagnes 
+      ! (la derni??re calcul??e dans la boucle k, vu que k est un indice croissant avec z)
+      ! et on multiplie l2limit par une fonction qui d??croit entre h et hlim
+              l2(ig,k)=l2limit(ig)*famorti(zlev(ig,k),h_oro(ig), hlim(ig))
+           ELSE                                                                    ! Au dessus de extent*h, on prend l2=l0 
+              l2(ig,k)=0.
+           END IF
+        ENDDO
+     ENDDO
+   ENDIF                                                                        ! pbl_lmixmin_alpha
+
+!==================================================================================
+! On prend le max entre la longueur de melange de blackadar et celle calcul??e
+! en fonction de la topographie 
+!===================================================================================
+
+
+ DO k=2,klev
+    DO ig=1,ngrid
+       lmix(ig,k)=MAX(MAX(l1(ig,k), l2(ig,k)),lmixmin)
+   ENDDO
+ ENDDO
+
+! Diagnostics
+
+ DO k=2,klev
+    DO ig=1,ngrid
+       jg=ni(ig)
+       l_mix(jg,k,nsrf)=lmix(ig,k)
+       l_mixmin(jg,k,nsrf)=l2(ig,k)
+    ENDDO
+ ENDDO
+ DO ig=1,ngrid
+    jg=ni(ig)
+    l_mix(jg,1,nsrf)=hlim(ig)
+ ENDDO
+
+
+
+END SUBROUTINE mixinglength
